#include <CppUTest/TestHarness.h>

extern "C" {
#include "IO.h"
#include "Control.h"
};

TEST_GROUP(Control)
{
    void setup(void) {
        IO_initialize();
        Control_initialize();
    }

    void teardown(void)
    {

    }
};

TEST(Control, switch1On_Then_Lamp1On)
{
    IO_powerSwitch1On();
    Control_control();
    CHECK_TRUE(IO_isLamp1On());
}

TEST(Control, switch1On_Off_Then_Lamp1On)
{
    IO_powerSwitch1On();
    Control_control();
    IO_powerSwitch1Off();
    Control_control();
    CHECK_TRUE(IO_isLamp1On());
}

TEST(Control, switch1On_Off_On_Then_Lamp1Off)
{
    IO_powerSwitch1On();
    Control_control();
    IO_powerSwitch1Off();
    Control_control();
    IO_powerSwitch1On();
    Control_control();
    CHECK_FALSE(IO_isLamp1On());
}

/***** End of File *****/
