#include <CppUTest/TestHarness.h>

extern "C" {
#include "IO.h"
};

TEST_GROUP(IOTest)
{
    void setup()
    {
        IO_initialize();
    }

    void teardown()
    {

    }
};

TEST(IOTest, create)
{
    IO_initialize();
    CHECK_FALSE(IO_isPowerSwitch1On());
    CHECK_FALSE(IO_isLamp1On());
    CHECK_FALSE(IO_isPowerSwitch2On());
    CHECK_FALSE(IO_isLamp2On());
}

TEST(IOTest, switch1On)
{
    IO_powerSwitch1On();
    CHECK_TRUE(IO_isPowerSwitch1On());
}

TEST(IOTest, switch1Off)
{
    IO_powerSwitch1On();
    IO_powerSwitch1Off();
    CHECK_FALSE(IO_isPowerSwitch1On());
}

TEST(IOTest, lamp1On)
{
    IO_lamp1On();
    CHECK_TRUE(IO_isLamp1On());
}

TEST(IOTest, Lamp1Off)
{
    IO_lamp1On();
    IO_lamp1Off();
    CHECK_FALSE(IO_isLamp1On());
}

TEST(IOTest, switch2On)
{
    IO_powerSwitch2On();
    CHECK_TRUE(IO_isPowerSwitch2On());
}

TEST(IOTest, switch2Off)
{
    IO_powerSwitch2On();
    IO_powerSwitch2Off();
    CHECK_FALSE(IO_isPowerSwitch2On());
}

TEST(IOTest, lamp2On)
{
    IO_lamp2On();
    CHECK_TRUE(IO_isLamp2On());
}

TEST(IOTest, Lamp2Off)
{
    IO_lamp2On();
    IO_lamp2Off();
    CHECK_FALSE(IO_isLamp2On());
}

/***** End of File *****/
